#===========================
# This function should be customized by students
#
#   F(x,y):
# Takes coordinates of a point (two float values)
# returns True/False depending on whether the point belongs to the coloured area
#===========================
from math import *

#===========================
##def F(x,y1):
##    y = y1
##    return ((y-0)/3)**2 + ((x-0)/6)**2 <= 1  # ellipsis (a=6,b=3)
#
##def F(x,y1):
##    y = y1-0.1*x**2
##    return ((y-0)/3)**2 + ((x-0)/6)**2 <= 1  # parabolized ellipsis (a=6,b=3)
#
##def F(x,y):
##    return (abs(y)>x*x) and (y<5) or (x**2+(y-6.5)**2<2.25)  # princess
#
##def F(x,y1):
##    y=y1+sin(x)
##    return ((y-0)/1)**2 + ((x-0)/8)**2 <= 1  # sinus'ed ellipsis (a=8,b=1)
#
##def F(x,y1):
##    y=y1+3*sin(x+pi*0.1)
##    return ((y-0)/0.25)**2 + ((x-0)/8)**2 <= 1  # sinus'ed ellipsis (a=8,b=0.25)
#
##def F(x,y1):
##    y=(y1+1.0)%3-1.0+sin(x+pi*0.1)
##    return ((y-0)/0.25)**2 + ((x-0)/8)**2 <= 1  # sinus'ed ellipsis (a=8,b=0.25)
#
def F(x1,y1):
    x=x1/2.4
    y=y1/2.3
    return sin(x**2-y**3)>(x**2+y**2)/17
#
##def F(x1,y1):
##    x=x1/2.4
##    y=y1/4
##    return sin(x**2-y**5)>(x**2+y**4)/17
#
##def F(x1,y1):
##    x=x1/2.4
##    y=y1/4
##    return sin(x**2-y**5)>(x**2+y**6)/17
#
##def F(x1,y1):
##    x=x1/1.2-0.02
##    y=y1/1.25
##    return sin(x**2-y**3)>(x**2+y**2)/50

#===========================

#===========================
from tkinter import *

def Paint(XYrange, CV):
        # destroy previous graphical contents to release resources
        # (TkInter specific behaviour)
        #
    CV.delete("all")
    
        # choose w(idth) and h(eight) so that to paint the squadric area
    w = min(int(canv["width"]), int(canv["height"]))
    h = w
    Xo = w//2
    Yo = h//2
    
        # choose dx,dy
    dx = min(XYrange/Xo, XYrange/Yo)
    dy = dx
    
        # iterate through all points of the plotted area
        # paint points for those f(x,y) returned True
        #
    for ys in range(h):
        y = (Yo-ys)*dy
        x0 = 0
        f1 = False
        for xs in range(w+1):
            if xs>=w:
                f2 = False
            else:
                x = (xs-Xo)*dx
                f2 = F(x,y)
            
            if not f1 and f2:
                x0 = xs
            elif f1 and not f2:
                CV.create_line(x0, ys, xs, ys)
                x0 = xs
            f1 = f2

        # draw OX and OY axes
    CV.create_line(0, Yo, w, Yo, fill="red")
    CV.create_line(Xo, 0, Xo, h, fill="red")

        # draw auxiliary markup
    clr1 = "#ff9090"
    for z in range(1,XYrange,1):
        xs = int(z/dx)
        ys = int(z/dy)
        CV.create_line(0, Yo+ys, w, Yo+ys, fill=clr1, dash=(4,4))
        CV.create_line(0, Yo-ys, w, Yo-ys, fill=clr1, dash=(4,4))
        CV.create_line(Xo+xs, 0, Xo+xs, h, fill=clr1, dash=(4,4))
        CV.create_line(Xo-xs, 0, Xo-xs, h, fill=clr1, dash=(4,4))
        
    # end od work!!
    return
#===========================

#===========================
def X_to_Xs(x, Xmin, Xrange, width):
    return int(width*(x-Xmin)/Xrange)
#=====
def Y_to_Ys(y, Ymin, Yrange, height):
    return height-int(height*(y-Ymin)/Yrange)
#=====
def PaintDots(XYrange, CV, tilesize):
    #Paint(XYrange, CV)

        # choose w(idth) and h(eight) so that to paint the squadric area
    w = min(int(canv["width"]), int(canv["height"]))
    h = w
    
        # choose dx,dy
    dx = tilesize
    dy = tilesize
    
        # iterate through the "tiled" area,
        # test one point per each tile.
        # paint results
        #
    r = 2
        
    y1 = float(-XYrange)
    y1s = Y_to_Ys(y1, -XYrange, 2*XYrange, h)
    
    while y1<=XYrange:
        y2 = y1+dy
        y2s = Y_to_Ys(y2, -XYrange, 2*XYrange, h)
        testY = y1
        yts = Y_to_Ys(testY, -XYrange, 2*XYrange, h)

        x1 = float(-XYrange)
        x1s = X_to_Xs(x1, -XYrange, 2*XYrange, w)
        while x1<=XYrange:
            x2 = x1+dx
            x2s = X_to_Xs(x2,-XYrange, 2*XYrange, w)
            testX = x1
            xts = X_to_Xs(testX,-XYrange, 2*XYrange, w)

            # test point
            res = F(testX, testY)

            # choose colours
            if res: cO,cF = "blue", "cyan"
            else:   cO,cF = "red",  "#ff6060"
            CV.create_oval(xts-r,yts-r, xts+r,yts+r, fill=cF, outline=cO, width=1)
            
            x1,x1s = x2,x2s
            # end cycle by x
            
        y1,y1s = y2,y2s
        # end cycle by y
    #--        
    return     # end PaintDots()
#=====
def PaintTile(XYrange, CV, tilesize):
    #Paint(XYrange, CV)

        # choose w(idth) and h(eight) so that to paint the squadric area
    w = min(int(canv["width"]), int(canv["height"]))
    h = w
    
        # choose dx,dy
    dx = tilesize
    dy = tilesize
    
        # iterate through the "tiled" area,
        # test one point per each tile.
        # paint results
    y1 = float(-XYrange)
    y1s = Y_to_Ys(y1, -XYrange, 2*XYrange, h)

    N = int(2*XYrange/dx+1+0.5) * int(2*XYrange/dy+1+0.5)
    countTiles = 0
    
    while y1<=XYrange:
        y2 = y1+dy
        y2s = Y_to_Ys(y2, -XYrange, 2*XYrange, h)
        testY = y1

        x1 = float(-XYrange)
        x1s = X_to_Xs(x1, -XYrange, 2*XYrange, w)
        while x1<=XYrange:
            x2 = x1+dx
            x2s = X_to_Xs(x2,-XYrange, 2*XYrange, w)
            testX = x1

            # test point
            res = F(testX, testY)

            # draw tile over marked-true points
                # The graphic above shows Button widgets bearing the standard bitmaps.
                # From left to right, they are 'error', 'gray75', 'gray50', 'gray25', 'gray12', 'hourglass', 'info', 'questhead', 'question', and 'warning'.
            if res:
                countTiles += 1
                CV.create_rectangle(x1s,y1s, x2s,y2s,
                                  stipple="gray25", fill="#80FF80", outline="green", width=1)

            x1,x1s = x2,x2s
            # end cycle by x
            
        y1,y1s = y2,y2s
        # end cycle by y
    #--
    print("tiles-count={0} of {1}, tile-size={2}x{2}, area={3}".format(countTiles, N, tilesize, countTiles*tilesize**2))
    return      # end PaintTile()
#=====

#=====
from random import Random, SystemRandom
RNG = Random()
#RNG = SystemRandom()
#=====
def PaintRandom(XYrange, CV):
    #Paint(XYrange, CV)

        # choose w(idth) and h(eight) so that to paint the squadric area
    w = min(int(canv["width"]), int(canv["height"]))
    h = w
    
        # iterate through the "tiled" area,
        # test one point per each tile.
        # paint results
    r = 2

    N = 1000
    cnt = 0
    for i in range(N):
        testX = RNG.uniform(-XYrange, XYrange)
        testY = RNG.uniform(-XYrange, XYrange)

        xts = X_to_Xs(testX, -XYrange, 2*XYrange, w)
        yts = Y_to_Ys(testY, -XYrange, 2*XYrange, h)

        # test point
        res = F(testX, testY)

        # choose colours
        if res:
            cO,cF = "blue", "cyan"
            cnt+=1
        else:
            cO,cF = "red",  "#ff6060"
        CV.create_oval(xts-r,yts-r, xts+r,yts+r, fill=cF, outline=cO, width=1)
        # end cycle by i
    print("matches: {} of {}, area={}".format(cnt, N, (cnt/N)*(2*XYrange)**2))
    #--
    return     # end PaintDots()
#=====
def PaintRandom2(XYrange, CV):
    #Paint(XYrange, CV)

        # choose w(idth) and h(eight) so that to paint the squadric area
    w = min(int(canv["width"]), int(canv["height"]))
    h = w
    
        # iterate through the "tiled" area,
        # test one point per each tile.
        # paint results
    r = 2

    N = 1000
    cnt = 0
    for i in range(N**2):
        testX = RNG.uniform(-XYrange, XYrange)
        testY = RNG.uniform(-XYrange, XYrange)

        # test point
        res = F(testX, testY)
        # choose colours
        if res:
            cnt+=1
    #--        
    print(" ^O^ 2 : {} of {}, area={}".format(cnt, N**2, (cnt/N**2)*(2*XYrange)**2))
    return     # end PaintDots()
#===========================


    #- - - - -
    # window settings
    #- - - - -
root = Tk()
root.title("Logic Areas")
root.minsize(300, 324)
root.geometry('400x424')
root.resizable(width=True, height=True)

    #- - - - -
    # top-side toolbox
    #- - - - -
frmMain = Frame(root, borderwidth=0, relief=FLAT)   # RAISED
frmMain.pack(fill=BOTH, expand=YES)

frmParams = Frame(frmMain, borderwidth=0, relief=FLAT)
frmParams.pack(side=TOP, expand=NO)

    #- - - - -
    # x,y range control
    #- - - - -
    
    #label (for range)
lb = Label(frmParams, text="Range:±")
lb.pack(side=LEFT)

    # input field for range ±x, ±y
rng=StringVar()
XYrange = Entry(frmParams, width=3, textvariable=rng)
XYrange.pack(side=LEFT)
rng.set("10")

#===========================
def doPaint(event):
    Paint(int(rng.get()), canv)
    return
#===========================

    # Repaint button
btn1 = Button(frmParams, width=7, text="Repaint")
btn1.pack(side=LEFT)
btn1.bind("<ButtonPress-1>", doPaint)


    #- - - - -
    # tiling controls
    #- - - - -
from tkinter import ttk

    #label (for tiling)
lb = Label(frmParams, text="Tiling size:")
lb.pack(side=LEFT)

    # input field for tiling size
tile = ttk.Combobox(frmParams,
                    values = ["2.0", "1.0", "0.5", "0.25", "0.1"],
                    width=5,
                    state="readonly")
tile.current(1)
tile.pack(side=LEFT)


#===========================
def doPaintDots(event):
    PaintDots(int(rng.get()), canv, float(tile.get()))
    return
#===========================
def doPaintTile(event):
    PaintTile(int(rng.get()), canv, float(tile.get()))
    return
#===========================

    # tiling-Dots button
btn2 = Button(frmParams, width=4, text="Dots")
btn2.pack(side=LEFT)
btn2.bind("<ButtonPress-1>", doPaintDots)

    # Tiling button
btn3 = Button(frmParams, width=4, text="Tile")
btn3.pack(side=LEFT)
btn3.bind("<ButtonPress-1>", doPaintTile)


#===========================
def doPaintRandom(event):
    PaintRandom(int(rng.get()), canv)
    return
#===========================

    # Motte-Carlo method button
btn4 = Button(frmParams, width=6, text="Random")
btn4.pack(side=LEFT)
btn4.bind("<ButtonPress-1>", doPaintRandom)


#===========================
def doPaintRandom2(event):
    PaintRandom2(int(rng.get()), canv)
    return
#===========================

    # Motte-Carlo method button
btn5 = Button(frmParams, width=2, text="R2")
btn5.pack(side=LEFT)
btn5.bind("<ButtonPress-1>", doPaintRandom2)


    #- - - - -
    # drawing area
    #- - - - -
canv = Canvas(frmMain, borderwidth=0, relief=SUNKEN, highlightthickness=0)   # SUNKEN RAISED width=250, height=250,
canv.pack(fill=BOTH, expand=YES)

#===========================
def onResize(event):
    canv["width"] = event.width
    canv["height"]= event.height
    Paint(int(rng.get()), canv)
    
canv.bind("<Configure>", onResize)
#===========================


    # 1-st paint
#Paint(int(rng.get()), canv)

# ...
root.mainloop()

